=== debian/changelog ===
i2pd (2.36.0-1) unstable; urgency=medium

  * New upstream release
    + Fix Yggdrasil support (Closes: #915501)
  * Bump Standards-Version to 4.5.1

 -- Yangfl <mmyangfl@gmail.com>  Sun, 21 Feb 2021 22:59:39 +0800
