=== debian/changelog ===
i2pd (2.39.0-1ubuntu1) jammy; urgency=medium

  * d/p/OpenSSL3.patch: Cherry-picked from upstream mainline to fix the build
    against OpenSSL 3.

 -- Simon Chopin <simon.chopin@canonical.com>  Fri, 26 Nov 2021 11:20:21 +0100

i2pd (2.39.0-1) unstable; urgency=medium

  * New upstream release
  * Use dh_apparmor to reload AppArmor profile on installation (Closes: #992489)
  * Bump Standards-Version to 4.6.0

 -- Yangfl <mmyangfl@gmail.com>  Tue, 31 Aug 2021 21:38:56 +0800
