=== debian/rules ===
--- 
+++ 
@@ -32,3 +32,6 @@
 
 override_dh_auto_build:
 	dh_auto_build --buildsystem=cmake
+
+execute_after_dh_install:
+	dh_apparmor -p i2pd --profile-name=usr.sbin.i2pd
